using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace ComboRelations
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(480, 296);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(512, 326);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		ImageList iList;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 3;
			int nRows = 10;

			for(int i = 0; i < nCols; i++)
			{
				if(i == 0)
					dt.Columns.Add(new DataColumn("parent", typeof(int)));
				else if(i == 1)
					dt.Columns.Add(new DataColumn("child"));
				else
					dt.Columns.Add(new DataColumn("bool", typeof(bool)));
			}

			Random r = new Random();

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					if(j == 0)
						dr[0] = r.Next(this.numberParentRows);
					else if(j == 1)
						dr[1] = string.Format("row{0} col{1}", i, j);
					else
						dr[2] = (i % 2) == 0;
				}

				dt.Rows.Add(dr);
			}

			this.gridDataBoundGrid1.DataSource = dt;

			parentTable = GetParentTable();
			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable});

			GridStyleInfo style = this.gridDataBoundGrid1.Binder.InternalColumns["bool"].StyleInfo;
			style.CellType = "Static";
			
			this.iList = new ImageList();
			iList.Images.Add(SystemIcons.Asterisk.ToBitmap());

			style.ImageList = iList;
			 
			 
			this.gridDataBoundGrid1.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(Grid_PrepareViewStyleInfo); 
			this.gridDataBoundGrid1.CurrentCellInitializeControlText +=new GridCurrentCellInitializeControlTextEventHandler(gridDataBoundGrid1_CurrentCellInitializeControlText);
			this.gridDataBoundGrid1.CellClick += new GridCellClickEventHandler(gridDataBoundGrid1_CellClick);
		}

		private void gridDataBoundGrid1_CellClick(object sender, GridCellClickEventArgs e)
		{
			if(e.ColIndex == 3 && e.RowIndex > 0 && e.RowIndex < this.gridDataBoundGrid1.Model.RowCount)
			{
				this.gridDataBoundGrid1[e.RowIndex, e.ColIndex].CellValue = ! (bool)this.gridDataBoundGrid1[e.RowIndex, e.ColIndex].CellValue;
			}
		}

		private void gridDataBoundGrid1_CurrentCellInitializeControlText(object sender, GridCurrentCellInitializeControlTextEventArgs e)
		{
			if(e.ColIndex == 3 && e.RowIndex > 0 && e.RowIndex < this.gridDataBoundGrid1.Model.RowCount)
			{
				e.ControlText = "";
				e.Cancel = true;
			}
		}

	 	private void Grid_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
		{
			if(e.ColIndex == 3 && e.RowIndex > 0 && e.RowIndex < this.gridDataBoundGrid1.Model.RowCount)
			{
				if(e.Style.CellValue != null && (bool)e.Style.CellValue)
				{
					e.Style.ImageIndex = 0;
				}
				else
				{
					e.Style.ImageIndex = -1;
				}
				e.Style.Text = "";
			}
		}

		 

		DataTable parentTable;
		 	
		private int numberParentRows = 5;
	 	private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));
			//method 1 *********************************
			//dt.Columns.Add(new DataColumn("ImageIndex", typeof(int)));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				//method 1 *********************************
				// dr[3] = i % 4;
				dt.Rows.Add(dr);
			}

			return dt;
		}

		
	}
}
